#!/bin/bash

TMP_DIR=/tmp/backup_client
mkdir -p $TMP_DIR

SERVER=$1
shift
for P in $*; do
	# connect to nanobackup server
	exec 5<>/dev/tcp/$SERVER/6333
	if [ "$?" != "0" ]; then
		echo "Unable to connect to server $SERVER:6333"
		exit 1
	fi
	if [ -f $P/.nanobackup_pre.sh ]; then
		$P/.nanobackup_pre.sh
	fi
	TARGZ_PREFIX=`echo $P | sed -e "s/\//__/g" -e "s/ /_/g"`
	tar czf $TMP_DIR/$TARGZ_PREFIX.tar.gz $P 2> /dev/null
	if [ -f $P/.nanobackup_post.sh ]; then
		$P/.nanobackup_post.sh
	fi
	echo $HOSTNAME >&5
	echo $P >&5
	echo $TARGZ_PREFIX >&5
	FILESIZE=`stat -c%s $TMP_DIR/$TARGZ_PREFIX.tar.gz`
	echo $FILESIZE >&5
	echo "sendind file $P  $FILESIZE bytes"
	dd bs=1 count=$FILESIZE < $TMP_DIR/$TARGZ_PREFIX.tar.gz >&5 2>/dev/null
	MD5SUM=`md5sum < $TMP_DIR/$TARGZ_PREFIX.tar.gz | cut -d' ' -f1`
	echo "sending md5"
	echo $MD5SUM >&5
	rm -f $TMP_DIR/$TARGZ_PREFIX.tar.gz
	cat <&5
	# close nanobackup connection
	exec 5<&-
done
exit 0
